/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                :    1 23:04:13 MSK 2002
    copyright            : (C) 2002 by Nikandrov George
    email                : gogan@ksi-linux.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

#include <qapplication.h>
#ifdef QWS
#include <qpe/qpeapplication.h>
#endif
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>

#include "qplot.h"

static const char rcsid[] = "$Id: main.cpp,v 1.1.1.1 2002/04/18 17:13:20 gogan Exp $";

int
main (int argc, char *argv[])
{
	
	int results[2];
	int commands[2];
	int pid;
	int retval;

	/* Pipe time */

	if (pipe (results) < 0) {
		fprintf (stderr, "Pipe error\n");
		exit (1);
	}
	if (pipe (commands) < 0) {
		fprintf (stderr, "Pipe error\n");
		exit (1);
	}
	
	/* Then fork */

	if ((pid = fork ()) < 0) {
		fprintf (stderr, "Fork error\n");
		exit (1);
	}

	if (pid > 0) {		/* I'm a parent */

		(void) setvbuf(stdout, NULL, _IOLBF, 0);

		close (results[1]);
		close (0);
		dup (results[0]);
		
		fcntl(0, F_SETFL, O_NONBLOCK);

		close (commands[0]);
#ifndef NO_INTERACTION
		close (1);
		dup (commands[1]);
#endif

#ifdef QWS
	        QPEApplication a (argc, argv);
#else
	        QApplication a (argc, argv);
#endif

		QPlot *qplot = new QPlot ();
		a.setMainWidget (qplot);

		qplot->show ();

		retval = a.exec ();
		
		return retval;
		
	} else {		/* I'm a child */
		close (commands[1]);
		close (0);
		dup (commands[0]);

		close (results[0]);
		close (1);
		dup (results[1]);
		close (2);
		dup (results[1]);

		char *envp[] = { "BC_LINE_LENGTH=30", NULL };

		execle ("/opt/QtPalmtop/bin/bc", "bc",
			"/opt/QtPalmtop/lib/qplot-const.b",
			"/opt/QtPalmtop/lib/qplot-math.b", 0, envp);
		execle ("/opt/Qtopia/bin/bc", "bc",
			"/opt/QtPalmtop/lib/qplot-const.b",
			"/opt/QtPalmtop/lib/qplot-math.b", 0, envp);
	}

}
