/******************************************************************************
                                qgraphwidget.h
                             -------------------
  begin    : Thu Feb 21 2002
  copyright: (C) 2002 by Nikandrov George
  email    : gogan@ksi-linux.com
  release  : $Id: qgraphwidget.h,v 1.1.1.1 2002/04/18 17:13:27 gogan Exp $
 ******************************************************************************
 *                                                                            *
 *    This program is free software; you can redistribute it and/or modify    *
 *    it under the terms of the GNU General Public License as published by    *
 *    the Free Software Foundation; either version 2 of the License, or       *
 *    (at your option) any later version.                                     *
 *                                                                            *
 *****************************************************************************/

#ifndef QGRAPHWIDGET_H
#define QGRAPHWIDGET_H

#define MARK_WID 1

#define CHUNK_SIZE 50
// Ugly hack
#define NAN -239239

#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qpaintdevice.h>
#include <qpixmap.h>
#include <qcheckbox.h>

#include <math.h>

#include <stdlib.h>
#include <unistd.h>

#include "calciface.h"
#include "qfuncedit.h"
// #include "qplot.h"
class QPlot;

/**
  *@author Nikandrov George
  */

class QGraphWidget : public QWidget  {
Q_OBJECT
public: 
	QGraphWidget(QWidget *parent=0, const char *name=0);
	~QGraphWidget();
	
	void GraphPlot(unsigned int func_no, const QColor *fcol);
	
	void setWidgetWithTimer(QPlot *plot);
	void setColorsArray (QColor *coloravail);
	void setScale(float Xmin, float Xmax, float Ymin, float Ymax);
	
	void PlotAllFuncs();	
signals:
	void scaleChanged( float xmin, float xmax, float ymin, float ymax );


protected:
	void paintEvent ( QPaintEvent * );
	void resizeEvent ( QResizeEvent * );
	void mousePressEvent ( QMouseEvent *e );
	void mouseMoveEvent ( QMouseEvent *e );
	void mouseReleaseEvent ( QMouseEvent *e );
	
	int getXReal ( float x );
	int getYReal ( float y );
	
private:
	void drawCoords ();
	unsigned int accuracy;
	QPainter *p;
	QPixmap *image;
	QPlot *dad;
	QColor *colors;
	int *values;
	bool mouse_button_down;
	int xdelta, ydelta;
	int mywid, myhei;
	long xsave, ysave;
	float xscale, yscale;
	float xmax, ymax, xmin, ymin;
	char first_time;
};

inline int QGraphWidget::getXReal(float x)
{
	return (int)rint( mywid * ( x - xmin ) / ( xmax - xmin ) );
}

inline int QGraphWidget::getYReal(float y)
{
	return (int)rint( myhei * ( y - ymax ) / ( ymin - ymax ) );
}

#endif
