/******************************************************************************
                                  qplot.h
                             -------------------
  begin    : Sat Feb 2 2002
  copyright: (C) 2002 by Nikandrov George
  email    : gogan@ksi-linux.com
  release  : $Id: qplot.h,v 1.1.1.1 2002/04/18 17:13:07 gogan Exp $
 ******************************************************************************
 *                                                                            *
 *    This program is free software; you can redistribute it and/or modify    *
 *    it under the terms of the GNU General Public License as published by    *
 *    the Free Software Foundation; either version 2 of the License, or       *
 *    (at your option) any later version.                                     *
 *                                                                            *
 *****************************************************************************/

#ifndef QPLOT_H
#define QPLOT_H

#include <qwidget.h>
#include <qmultilineedit.h>
#include <qapplication.h>
#include <qspinbox.h>
#include <qlineedit.h>
#include <qtimer.h>
#include <qpainter.h>
#include <qscrollview.h>
#include <qlayout.h>
#include <qvbox.h>
#include <qtabwidget.h>
#include <qcombobox.h>
#include <qtextview.h>

#include "qinputdialog.h"

#include <qstring.h>
#include <qregexp.h>

#ifdef QWS
#include <qpe/config.h>
#include <qpe/qpeapplication.h>
#include <qpe/fileselector.h>
#include <qpe/qcopenvelope_qws.h>
#include <qpe/global.h>
#endif

#define FUNCS_NUM 30

#ifndef __USE_XOPEN_EXTENDED
#define	__USE_XOPEN_EXTENDED
#include <unistd.h>
#undef __USE_XOPEN_EXTENDED
#else
#include <unistd.h>
#endif

#include "qplotview.h"
#include "qgraphwidget.h"
#include "qfuncedit.h"
#include "calciface.h"

/**
  *@author Nikandrov George
  */

class QPlot : public QPlotView  {
   Q_OBJECT
public: 
	QPlot(QWidget *parent=0, const char *name=0);
	~QPlot();
	
	void abortTimer();
	void resumeTimer();
	
public slots:
	void executeStatement();
	void acceptResult();
	void FeedFunctions();
	void clearScreen();
	void callQuit();
	void setScale();
	void setGraphScale();
	void updateXYminmax(float xmin, float xmax, float ymin, float ymax);
	void setGraphPreset(int num);
	void setAngMode(int num);
	void SolveNewton();
	void SolveQuadratic();
	
	void ZoomIn2D();
	void ZoomOut2D();
	
	void OpenProgrammingFile(const DocLnk &f);
	void NewProgrammingFile(const DocLnk &f);
	
	void setDocument(const QString &fn);

public:
	QFuncEdit* *funcs;
	QColor *colors;
	
protected:
	int line;
        int col;
	QTimer *time_out;
	QScrollView *func_scroll;
	QVBoxLayout *lay;
	QVBox *func_lay;
	FileSelector *fileSelector;
	const char *buffer;

};

#endif
