/***************************************************************************
                          qplotmath.cpp  -  description
                             -------------------
    begin                : Wed Feb 6 2002
    copyright            : (C) 2002 by Nikandrov George
    email                : gogan@ksi-linux.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "qplotmath.h"

QPlotMath::QPlotMath(QWidget *parent, const char *name, Qt::WFlags f )
: QPlotMathBrd(parent,name,f)
{
    setFont( QFont( "smallsmooth", 6 ) );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, sizePolicy().hasHeightForWidth() ) );
}

QPlotMath::~QPlotMath()
{

}

void QPlotMath::resetState()
{

}

QSize QPlotMath::sizeHint() const
{
    return QSize( 240, 83 );
}

void QPlotMath::generateText(const QString& s)
{
    for (int i=0; i<(int)s.length(); i++) {
	emitKey(s[i].unicode(), 0, 0,  true, false);
	emitKey(s[i].unicode(), 0, 0, false, false);
    }
}

void QPlotMath::addEnter()
{
    emitKey(0, Key_Enter, 0,  true, false);
    emitKey(0, Key_Enter, 0, false, false);
}

void QPlotMath::BackSpace()
{
    emitKey(0, Key_Backspace, 0,  true, false);
    emitKey(0, Key_Backspace, 0, false, false);
}

void QPlotMath::add0(){
	generateText("0");
}

void QPlotMath::add1(){
	generateText("1");
}

void QPlotMath::add2(){
	generateText("2");
}

void QPlotMath::add3(){
	generateText("3");
}

void QPlotMath::add4(){
	generateText("4");
}

void QPlotMath::add5(){
	generateText("5");
}

void QPlotMath::add6(){
	generateText("6");
}

void QPlotMath::add7(){
	generateText("7");
}

void QPlotMath::add8(){
	generateText("8");
}

void QPlotMath::add9(){
	generateText("9");
}

void QPlotMath::addExp(){
	generateText("*10^");
}

void QPlotMath::addDot(){
	generateText(".");
}

void QPlotMath::addAdd(){
	generateText("+");
}

void QPlotMath::addSub(){
	generateText("-");
}

void QPlotMath::addDiv(){
	generateText("/");
}

void QPlotMath::addMul(){
	generateText("*");
}

void QPlotMath::addSin(){
	generateText("sin(");
}

void QPlotMath::addCos(){
	generateText("cos(");
}

void QPlotMath::addTan(){
	generateText("tan(");
}

void QPlotMath::addCot(){
	generateText("cot(");
}

void QPlotMath::addSec(){
	generateText("sec(");
}

void QPlotMath::addCosec(){
	generateText("csc(");
}

void QPlotMath::addArcsin(){
	generateText("asin(");
}

void QPlotMath::addArccos(){
	generateText("acos(");
}

void QPlotMath::addArctan(){
	generateText("atan(");
}

void QPlotMath::addArccot(){
	generateText("acot(");
}

void QPlotMath::addArcsec(){
	generateText("asec(");
}

void QPlotMath::addArccosec(){
	generateText("acsc(");
}

void QPlotMath::addSinh(){
	generateText("sinh(");
}

void QPlotMath::addCosh(){
	generateText("cosh(");
}

void QPlotMath::addTanh(){
	generateText("tanh(");
}

void QPlotMath::addCoth(){
	generateText("coth(");
}

void QPlotMath::addSech(){
	generateText("sech(");
}

void QPlotMath::addCosech(){
	generateText("csch(");
}

void QPlotMath::addArsinh(){
	generateText("asinh(");
}

void QPlotMath::addArcosh(){
	generateText("acosh(");
}

void QPlotMath::addArtanh(){
	generateText("atanh(");
}

void QPlotMath::addArcoth(){
	generateText("acoth(");
}

void QPlotMath::addArsech(){
	generateText("asech(");
}

void QPlotMath::addArcosech(){
	generateText("acsch(");
}

void QPlotMath::addPow(){
	generateText("^");
}

void QPlotMath::addLog(){
	generateText("log(");
}

void QPlotMath::addLn(){
	generateText("ln(");
}

void QPlotMath::addLg(){
	generateText("lg(");
}

void QPlotMath::addLP(){
	generateText("(");
}

void QPlotMath::addRP(){
	generateText(")");
}

void QPlotMath::addE(){
	generateText("exp(");
}

void QPlotMath::add10E(){
	generateText("10^");
}

void QPlotMath::addZap(){
	generateText(",");
}

void QPlotMath::addSqrt(){
	generateText("sqrt(");
}

void QPlotMath::addCbrt(){
	generateText("cbrt(");
}

void QPlotMath::addSqr(){
	generateText("^2");
}

void QPlotMath::addCub(){
	generateText("^3");
}

void QPlotMath::addVariableA(){
	generateText("a");
}

void QPlotMath::addVariableB(){
	generateText("b");
}

void QPlotMath::addVariableC(){
	generateText("c");
}

void QPlotMath::addVariableD(){
	generateText("d");
}

void QPlotMath::addVariableE(){
	generateText("e");
}

void QPlotMath::addVariableF(){
	generateText("f");
}

void QPlotMath::addVariableG(){
	generateText("g");
}

void QPlotMath::addVariableH(){
	generateText("h");
}

void QPlotMath::addVariableI(){
	generateText("i");
}

void QPlotMath::addVariableJ(){
	generateText("j");
}

void QPlotMath::addVariableK(){
	generateText("k");
}

void QPlotMath::addVariableL(){
	generateText("l");
}

void QPlotMath::addVariableM(){
	generateText("m");
}

void QPlotMath::addVariableN(){
	generateText("n");
}

void QPlotMath::addVariableO(){
	generateText("o");
}

void QPlotMath::addVariableP(){
	generateText("p");
}

void QPlotMath::addVariableQ(){
	generateText("q");
}

void QPlotMath::addVariableR(){
	generateText("r");
}

void QPlotMath::addVariableS(){
	generateText("s");
}

void QPlotMath::addVariableT(){
	generateText("t");
}

void QPlotMath::addVariableU(){
	generateText("u");
}

void QPlotMath::addVariableV(){
	generateText("v");
}

void QPlotMath::addVariableW(){
	generateText("w");
}

void QPlotMath::addVariableX(){
	generateText("x");
}

void QPlotMath::addVariableY(){
	generateText("y");
}

void QPlotMath::addVariableZ(){
	generateText("z");
}

void QPlotMath::addIntegral(){
	generateText("int(");
}

void QPlotMath::addSum(){
	generateText("sum(");
}

void QPlotMath::addDifferential(){
	generateText("ddx(");
}

void QPlotMath::addQuadDiff(){
	generateText("d2dx2(");
}

void QPlotMath::addHex10(){
	generateText("A");
}

void QPlotMath::addHex11(){
	generateText("B");
}

void QPlotMath::addHex12(){
	generateText("C");
}

void QPlotMath::addHex13(){
	generateText("D");
}

void QPlotMath::addHex14(){
	generateText("E");
}

void QPlotMath::addHex15(){
	generateText("F");
}

void QPlotMath::addPi(){
	generateText("pi");
}

void QPlotMath::addE271828(){
	generateText("e");
}

void QPlotMath::AddPhysConst(int i){
	switch (i+1) {
	    case 1:	generateText("protmass"); break;
	    case 2:	generateText("neutmass"); break;
	    case 3:	generateText("elecmass"); break;
	    case 4:	generateText("muonmass"); break;
	    case 5:	generateText("bohrradius"); break;
	    case 6:	generateText("plancksconst"); break;
	    case 7:	generateText("nuclmagn"); break;
	    case 8:	generateText("bohrmagn"); break;
	    case 9:	generateText("plancksconstbar"); break;
	    case 10:	generateText("finestruct"); break;
	    case 11:	generateText("elecradius"); break;
	    case 12:	generateText("eleccompwlen"); break;
	    case 13:	generateText("protgmrat"); break;
	    case 14:	generateText("protcompwlen"); break;
	    case 15:	generateText("neutcompwlen"); break;
	    case 16:	generateText("rydbconst"); break;
	    case 17:	generateText("amu"); break;
	    case 18:	generateText("protmm"); break;
	    case 19:	generateText("elecmm"); break;
	    case 20:	generateText("neutmm"); break;
	    case 21:	generateText("muonmm"); break;
	    case 22:	generateText("faradconst"); break;
	    case 23:	generateText("elemcharg"); break;
	    case 24:	generateText("navog"); break;
	    case 25:	generateText("boltz"); break;
	    case 26:	generateText("molarvol"); break;
	    case 27:	generateText("molgasconst"); break;
	    case 28:	generateText("lgtspd"); break;
	    case 29:	generateText("firstradconst"); break;
	    case 30:	generateText("secndradconst"); break;
	    case 31:	generateText("stefboltzconst"); break;
	    case 32:	generateText("vacprmt"); break;
	    case 33:	generateText("vacprmb"); break;
	    case 34:	generateText("magnfluxquant"); break;
	    case 35:	generateText("accgrav"); break;
	    case 36:	generateText("au"); break;
	    case 37:	generateText("pc"); break;
	    case 38:	generateText("tempcels"); break;
	    case 39:	generateText("newtgrav"); break;
	    case 40:	generateText("atm"); break;
	}
}

void QPlotMath::AddFuncNum(int i){
	generateText(QString("f%1(").arg(i+1));
}

void QPlotMath::addAbs(){
	generateText("abs(");
}

void QPlotMath::addSign(){
	generateText("sign(");
}

void QPlotMath::addFact(){
	generateText("fact(");
}

void QPlotMath::addBessel(){
	generateText("j(");
}

void QPlotMath::addLast(){
	generateText("last");
}

void QPlotMath::addCnk(){
	generateText("c(");
}

void QPlotMath::addPnk(){
	generateText("p(");
}

