/***************************************************************************
                          qplotmath.h  -  description
                             -------------------
    begin                : Wed Feb 6 2002
    copyright            : (C) 2002 by Nikandrov George
    email                : gogan@ksi-linux.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QPLOTMATH_H
#define QPLOTMATH_H

#include <qwidget.h>
#include "qplotmathbrd.h"

/**
  *@author Nikandrov George
  */

class QPlotMath : public QPlotMathBrd  {
   Q_OBJECT
public: 
	QPlotMath(QWidget *parent=0, const char *name=0, Qt::WFlags f=0);
	~QPlotMath();

	void resetState();

	QSize sizeHint() const;
signals:
        void key( ushort scan, ushort uni, ushort mod, bool press, bool repeat );
	
protected:
	void emitKey( ushort uni, ushort scan, ushort mod, bool press, bool repeat )
		    { key(uni,scan,mod,press,repeat); }
	void generateText(const QString& s);

	
private slots:
        void BackSpace();
        void add0();
        void add1();
        void add2();
        void add3();
        void add4();
        void add5();
        void add6();
        void add7();
        void add8();
        void add9();
        void addExp();
        void addDot();
        void addEnter();
        void addAdd();
        void addSub();
        void addDiv();
        void addMul();
        void addSin();
        void addCos();
        void addTan();
        void addCot();
        void addSec();
        void addCosec();
        void addArcsin();
        void addArccos();
        void addArctan();
        void addArccot();
        void addArcsec();
        void addArccosec();
        void addSinh();
        void addCosh();
        void addTanh();
        void addCoth();
        void addSech();
        void addCosech();
        void addArsinh();
        void addArcosh();
        void addArtanh();
        void addArcoth();
        void addArsech();
        void addArcosech();
        void addPow();
        void addLog();
        void addLn();
        void addLg();
        void addRP();
        void addLP();
        void addE();
        void add10E();
	void addZap();
	void addSqrt();
	void addCbrt();
	void addSqr();
	void addCub();
	void addAbs();
	void addSign();
	void addLast();
	void addBessel();

	void addFact();
	void addCnk();
	void addPnk();

	void addVariableA();
	void addVariableB();
	void addVariableC();
	void addVariableD();
	void addVariableE();
	void addVariableF();
	void addVariableG();
	void addVariableH();
	void addVariableI();
	void addVariableJ();
	void addVariableK();
	void addVariableL();
	void addVariableM();
	void addVariableN();
	void addVariableO();
	void addVariableP();
	void addVariableQ();
	void addVariableR();
	void addVariableS();
	void addVariableT();
	void addVariableU();
	void addVariableV();
	void addVariableW();
	void addVariableX();
	void addVariableY();
	void addVariableZ();
	
	void addDifferential();
	void addQuadDiff();
	void addIntegral();
	void addSum();
	
	void addHex10();
	void addHex11();
	void addHex12();
	void addHex13();
	void addHex14();
	void addHex15();
	
	void addPi();
	void addE271828();
	void AddPhysConst(int);
	void AddFuncNum(int);
};

#endif
